#include<stdio.h>
int L[101];

int Pot(int n,int p) {
  int i=0;
  while(n>=p) { n/=p; i+=n; }
  return i;
}

int Val(int s,int k) {
  int p2,p3,p5,p7,i;
  p2=Pot(s,2)-(Pot(k,2)+Pot(s-k-1,2));
  p3=Pot(s,3)-(Pot(k,3)+Pot(s-k-1,3));
  p5=Pot(s,5)-(Pot(k,5)+Pot(s-k-1,5));
  p7=Pot(s,7)-(Pot(k,7)+Pot(s-k-1,7));
  i=1;
  while(p2--) i*=2;
  while(p3--) i*=3;
  while(p5--) i*=5;
  while(p7--) i*=7;
  return i;
}

void Lagrange(int n)
{
int k,i;
for (k=1;k<n;k++)
	{
	  L[k-1]=Val(n,k-1);
	}
}

int main(void)
{
int T,C,S,i,j,k,x[100];
int temp;
printf("%d\n",Val(5,3)); 
scanf("%d",&T);
for (i=0;i<T;i++)
{
	scanf("%d %d",&S,&C);
	for (j=0;j<S;j++)
		scanf("%d",&x[j]);
	for (j=0;j<C;j++)
	{
		Lagrange(S+j);
		temp=0;
		for (k=0;k<S+j;k++)
			temp+=x[k]*L[k];
		x[S+j]=temp;
		printf("%d ",temp);
	}
printf("\n");
}
return 0;
}
